/**
 * TP2.java
 * 
 * Time-stamp: <2012-12-21 02:09:40 ftaiani>
 * @author Francois Taiani   <f.taiani@lancaster.ac.uk>
 * $Id$
 * 
 */

class Incrementer extends Thread {
  public void run() {
    for(int i=0;i<500000000;i++) {
      TP2.counter++;
    }
	}
} // EndClass Inserter

class Reader extends Thread {
  public void run() {
    for(int i=0;i<500000000;i++) {
      long x = TP2.counter ;
      if (i%100000000==0) System.err.println(this.getId()+" : "+x);
    }
  }
} // EndClass Reader


/**
 * @author Francois Taiani   <f.taiani@lancaster.ac.uk>
 */
public class TP2 {

  static long counter = 0;

  public static void main(String[] args) throws InterruptedException {

    Thread[] readers      = new Thread[15];
    Thread[] incrementers = new Thread[5];

    for(int i=0;i< 5;i++) {
      readers[i] = new Reader();
      readers[i].start();

      incrementers[i] = new Incrementer();
      incrementers[i].start();
    }
    for(int i=0;i<10;i++) {
      readers[i+5] = new Reader();
      readers[i+5].start();
    }

    // waiting for incrementers to finish
    for(int i=0;i< 5;i++) {
      incrementers[i].join();
    }

    // waiting for readers to finish
    for(int i=0;i<15;i++) {
      readers[i].join();
    }
    
    System.err.println("End value: "+ counter);

  } // EndMain

} // EndClass TP2
